/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Quote
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Quote {
  @SerializedName("context")
  private Model211 context = null;

  @SerializedName("quote_expire_at")
  private String quoteExpireAt = null;

  @SerializedName("products")
  private Model223 products = null;

  @SerializedName("payment_modes")
  private Model224 paymentModes = null;

  @SerializedName("is_premium_collected_by_axa")
  private Boolean isPremiumCollectedByAxa = null;

  public Quote context(Model211 context) {
    this.context = context;
    return this;
  }

   /**
   * Get context
   * @return context
  **/
  @ApiModelProperty(required = true, value = "")
  public Model211 getContext() {
    return context;
  }

  public void setContext(Model211 context) {
    this.context = context;
  }

  public Quote quoteExpireAt(String quoteExpireAt) {
    this.quoteExpireAt = quoteExpireAt;
    return this;
  }

   /**
   * Date and time of quotes expiration. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).
   * @return quoteExpireAt
  **/
  @ApiModelProperty(required = true, value = "Date and time of quotes expiration. UTC datetime, RFC3339 format (YYYY-MM-DDTHH:mm:ssZ).")
  public String getQuoteExpireAt() {
    return quoteExpireAt;
  }

  public void setQuoteExpireAt(String quoteExpireAt) {
    this.quoteExpireAt = quoteExpireAt;
  }

  public Quote products(Model223 products) {
    this.products = products;
    return this;
  }

   /**
   * Get products
   * @return products
  **/
  @ApiModelProperty(required = true, value = "")
  public Model223 getProducts() {
    return products;
  }

  public void setProducts(Model223 products) {
    this.products = products;
  }

  public Quote paymentModes(Model224 paymentModes) {
    this.paymentModes = paymentModes;
    return this;
  }

   /**
   * Get paymentModes
   * @return paymentModes
  **/
  @ApiModelProperty(value = "")
  public Model224 getPaymentModes() {
    return paymentModes;
  }

  public void setPaymentModes(Model224 paymentModes) {
    this.paymentModes = paymentModes;
  }

  public Quote isPremiumCollectedByAxa(Boolean isPremiumCollectedByAxa) {
    this.isPremiumCollectedByAxa = isPremiumCollectedByAxa;
    return this;
  }

   /**
   * Indicates if the payment on policy subscription shoud be collected by AXA.
   * @return isPremiumCollectedByAxa
  **/
  @ApiModelProperty(example = "true", required = true, value = "Indicates if the payment on policy subscription shoud be collected by AXA.")
  public Boolean isIsPremiumCollectedByAxa() {
    return isPremiumCollectedByAxa;
  }

  public void setIsPremiumCollectedByAxa(Boolean isPremiumCollectedByAxa) {
    this.isPremiumCollectedByAxa = isPremiumCollectedByAxa;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Quote quote = (Quote) o;
    return Objects.equals(this.context, quote.context) &&
        Objects.equals(this.quoteExpireAt, quote.quoteExpireAt) &&
        Objects.equals(this.products, quote.products) &&
        Objects.equals(this.paymentModes, quote.paymentModes) &&
        Objects.equals(this.isPremiumCollectedByAxa, quote.isPremiumCollectedByAxa);
  }

  @Override
  public int hashCode() {
    return Objects.hash(context, quoteExpireAt, products, paymentModes, isPremiumCollectedByAxa);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Quote {\n");
    
    sb.append("    context: ").append(toIndentedString(context)).append("\n");
    sb.append("    quoteExpireAt: ").append(toIndentedString(quoteExpireAt)).append("\n");
    sb.append("    products: ").append(toIndentedString(products)).append("\n");
    sb.append("    paymentModes: ").append(toIndentedString(paymentModes)).append("\n");
    sb.append("    isPremiumCollectedByAxa: ").append(toIndentedString(isPremiumCollectedByAxa)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

